#ifndef BatchLab_AsciiTree_h
#define BatchLab_AsciiTree_h

// Inheritance :
#include <BatchLab/Core/MemoryTree.h>

namespace Lib {class Out;}

namespace AIDA {class ITuple;}

namespace BatchLab {

class AsciiTree : public MemoryTree {
public: //Slash::Core::IManager
  virtual void* cast(const std::string&) const;
public: //AIDA/ITree
  virtual bool commit();
  virtual std::string storeName() const;
  virtual std::string storeType() const; //AIDA-v3r3p0
  virtual bool isReadOnly() const; //AIDA-v3r3p0
public:
  AsciiTree(Slash::Core::ISession&,const std::string&,const std::string&,bool,bool,const std::string&);
  virtual ~AsciiTree();
  void writeTuple(Lib::Out&,
                  const std::string&,const std::string&,
                  AIDA::ITuple&);
  void setHippoStyle(bool);
  bool createNew() const;
private:
  std::string fStoreName;
  bool fReadOnly;
  bool fCreateNew;
  bool fHippoStyle;
};

}

#endif
